<?php
/*
 *
 * pnp4nagios template for check_iperf3.
 *
 * use RRD_STORAGE_TYPE = MULTIPLE.
 *
 * Author: Philippe Kueck <projects at unixadm dot org>
 *
 */

$myds = array();
for ($i = 1; $i <= count($DS); $i++) {$myds[$NAME[$i]] = $i;}

// ---------- Transfer rate ----------
$i = 0;
$ds_name[$i] = "iperf3";
$opt[$i] = " --vertical-label \"transfer rate\" -b 1000 -E --title \"$hostname / iperf3\" ";
$def[$i] = "";

for ($intv = 0; array_key_exists("bps$intv", $myds); $intv++) {
	$dskey = "bps$intv";
	$def[$i] .= rrd::def($dskey, $RRDFILE[$myds[$dskey]], $DS[$myds[$dskey]], "AVERAGE");
	$def[$i] .= rrd::area($dskey, "#00ff0019", "");
	$def[$i] .= rrd::gprint($dskey, array("MIN", "MAX"), "%7.2lf %s");
}

$dskey = "bps_avg";
$def[$i] .= rrd::def($dskey, $RRDFILE[$myds[$dskey]], $DS[$myds[$dskey]], "AVERAGE");
$def[$i] .= rrd::line1($dskey, "#0000ff", "average transfer rate");
$def[$i] .= rrd::gprint($dskey, array("LAST", "MIN", "MAX", "AVERAGE"), "%7.2lf %s");

if ($WARN[$myds[$dskey]] != "")
	$def[$i] .= rrd::hrule($WARN[$myds[$dskey]], "#c0c000");
if ($CRIT[$myds[$dskey]] != "")
	$def[$i] .= rrd::hrule($CRIT[$myds[$dskey]], "#ff0000");

// --------- Retransmissions ----------
$i++;
$ds_name[$i] = "iperf3";
$opt[$i] = " --title \"$hostname / iperf3\" ";
$dskey = "retrans_sum";
$def[$i] = "";
$def[$i] .= rrd::def($dskey, $RRDFILE[$myds[$dskey]], $DS[$myds[$dskey]], "AVERAGE");
$def[$i] .= rrd::gradient($dskey, "ff5c00", "ffdc00", "Retransmissions", 20) ;
$def[$i] .= rrd::gprint($dskey, array("LAST", "MAX", "AVERAGE"), "%3lf");
$def[$i] .= rrd::line1($dskey, "#000000");

if ($WARN[$myds[$dskey]] != "")
	$def[$i] .= rrd::hrule($WARN[$myds[$dskey]], "#c0c000");
if ($CRIT[$myds[$dskey]] != "")
	$def[$i] .= rrd::hrule($CRIT[$myds[$dskey]], "#ff0000");

// --------- CPU usage ----------
$i++;
$ds_name[$i] = "iperf3";
$opt[$i] = " --title \"$hostname / iperf3\" ";
$dskey = "local_cpu";
$def[$i] = "";
$def[$i] .= rrd::def($dskey, $RRDFILE[$myds[$dskey]], $DS[$myds[$dskey]], "AVERAGE");
$def[$i] .= rrd::line1($dskey, "#00ff00", "local cpu usage ");
$def[$i] .= rrd::gprint($dskey, array("LAST", "MAX", "AVERAGE"), "%5.2lf%%");
$dskey = "remote_cpu";
$def[$i] .= rrd::def($dskey, $RRDFILE[$myds[$dskey]], $DS[$myds[$dskey]], "AVERAGE");
$def[$i] .= rrd::line1($dskey, "#0000ff", "remote cpu usage");
$def[$i] .= rrd::gprint($dskey, array("LAST", "MAX", "AVERAGE"), "%5.2lf%%");
?>
